#!/usr/bin/env python

#####################################################
# Name: serviceDaemon.py
# Author: Amit Sharma
# Description: Startup program that starts an engine.
#   uses dbus 
# apt-get install python-gobject python-dbus
#####################################################


import gobject
import dbus
import dbus.service
import dbus.mainloop.glib
from xml.dom import minidom, Node
import string
import subprocess
import os
import signal
import sys


ipaddress = "localhost"

enginename = ""
service_string = ""
lib_string = ""
path_string = ""
device_string = ""
default_string = ""

service_dict = {}
gel_dict  = {}
process_dict = {}

class ServiceOptions:

  def __init__(self,doc):
    global service_string
    global path_string
    global lib_string
    global device_string
    global default_string
    global service_dict
    global enginename    
    service_string = ""
    path_string = ""
    lib_string = ""
    device_string = ""
    default_string = ""
    new_device_string = ""
    for child in doc.childNodes:
        print child.tagName
	if(child.nodeType == Node.ELEMENT_NODE and child.tagName == "Service"):
	  service_string = ""
	  service_string = service_string + child.getAttribute("name")
          self.processOptions(child)
	  gel_dict.clear()
	  print "#########"
	  print device_string
	  print default_string
	  if(len(device_string) != 0):
	    os.system("nilsdev > /tmp/nilsdev.txt");
	    f = open("/tmp/nilsdev.txt","r")
	    fr = f.readlines();
	    f.close()
            print fr
	    found = 0
	    for line in range(0,len(fr)):
	      stale = string.find(fr[line],"[Not Present]")
	      #print "stale" + str(stale)
	      if (stale == -1):
                ret = string.find(fr[line],device_string)
                if (ret != -1):
                  print "found the string " + device_string
                  found = 1
                  at = string.split(fr[line],":")
                  atn = string.split(at[1],'"')
                  new_device_string = atn[1]
            if (found == 1):
	      service_string = service_string + " " +  new_device_string
	    else:
	      print "######### using default string"
	      service_string = service_string + " " + default_string
	  replaced_string = string.replace(service_string,"localhost",ipaddress)
	  print "##### svc : " + replaced_string
	  gel_dict["exe"] = replaced_string
	  gel_dict["path"] = path_string
	  gel_dict["lib_path"] = lib_string
	  gel_dict["device"] = device_string
	  gel_dict["default_device"] = default_string
          service_dict[enginename] =  gel_dict

  def ServiceDebug(self):
    global service_string
    global path_string
    global lib_string
    global service_dict
    global device_string
    global default_string
    print "service_string: " + service_string
    print "path_string: " + path_string
    print "lib_string: " + lib_string
    print "device_string: " + device_string
    print "default_string: " + default_string
    print "service_dict: " 
    print service_dict
    keylist = service_dict.keys()
    for i in range(0,len(keylist)):
      a =  service_dict[keylist[i]]
      print a['exe']
      print a['path']
      print a['lib_path']

  def execute(self,e_name):
    global service_string
    global path_string
    global lib_string
    global service_dict
    global device_string
    global default_string
    keylist = service_dict.keys()
    for i in range(0,len(keylist)):
      if(keylist[i] == e_name):
        a =  service_dict[keylist[i]]
	print a['exe']
	#sys.stderr.write("%s" %(a['exe']))
        process = subprocess.Popen(string.split(a['exe']," "),shell=False,env={"PATH": "/usr/local/sbin:/usr/local/bin:/usr/sbin:/usr/bin:/sbin:/bin:/usr/X11R6/bin:" + a['path'],"LD_LIBRARY_PATH" : "$LD_LIBRARY_PATH:" +a['lib_path'],"QT_DIR" : "/space/cp/x86/qt","QT_PLUGIN_PATH": "/space/cp/target/X86/UI/plugins","DISPLAY" : ":0.0" })
        process_dict[e_name] = process

  
  def processOptions(self,elementnode):
    global service_string
    global lib_string
    global path_string
    global device_string
    global default_string
    global enginename
    defualt_string = ""
    device_string = ""
    for cval in elementnode.childNodes:
      if(cval != 0):
	inter = cval.nextSibling
	if(inter != None):
	  # Parse <Options>
          if inter.nodeType == Node.ELEMENT_NODE:
            if(inter.tagName == 'Options'):         
              for childval in inter.childNodes:
	        if(childval != 0):
                  if(childval.nodeType == Node.ELEMENT_NODE):
                    print childval.tagName
                  if(childval.nodeType == Node.TEXT_NODE):
	            service_string = service_string + " " + string.strip(childval.data)
	    # Parse <libpath>
            if(inter.tagName == 'libpath'):         
              for childval in inter.childNodes:
	        if(childval != 0):
                  if(childval.nodeType == Node.ELEMENT_NODE):
                    print childval.tagName
                  if(childval.nodeType == Node.TEXT_NODE):
		    #lib_string = "export LD_LIBRARY_PATH=$LD_LIBRARY_PATH:"
	            lib_string = lib_string + string.strip(childval.data)
  	    # Parse <path>
            if(inter.tagName == 'path'):
              for childval in inter.childNodes:
	        if(childval != 0):
                  if(childval.nodeType == Node.ELEMENT_NODE):
                    print childval.tagName
                  if(childval.nodeType == Node.TEXT_NODE):
		    #path_string = "export PATH=$PATH:"
	            path_string = path_string + string.strip(childval.data)
    	    # Parse <NIDevice>
            if(inter.tagName == 'NIDevice'):
	      device_string = inter.getAttribute("name")
              for childval in inter.childNodes:
	        if(childval != 0):
                  if(childval.nodeType == Node.ELEMENT_NODE):
    	            # Parse <Default>
                    if(childval.tagName == 'Default'):
                      for DefNode in childval.childNodes:
                        if(DefNode.nodeType == Node.TEXT_NODE):
			  default_string = string.strip(DefNode.data)



class serviceException(dbus.DBusException):
  _dbus_error_name = "CommonPlatform.Engine.serviceException"
  


class Service(dbus.service.Object):

  def __init__(self,conn,object_path='/CommonPlatform/Engine/ServiceInterface/Object'):
      dbus.service.Object.__init__(self,conn,object_path)

  #Emit Signal Done
  @dbus.service.signal('CommonPlatform.Engine.ServiceInterface')
  def DoneSignal(self,message):
     print "engine DoneSignal"
     pass

  @dbus.service.method('CommonPlatform.Engine.ServiceInterface')
  def emitDoneSignal(self):
    self.DoneSignal('Done Loading')
    print "emitted  : signal"
    return 'Signal emitted'


  #Emit Start Signal 
  @dbus.service.signal(dbus_interface='CommonPlatform.Engine.ServiceInterface',signature='s')
  def StartSignal(self,message):
     print "engine : startSignal " + message 
     pass

  @dbus.service.method('CommonPlatform.Engine.ServiceInterface',in_signature='s',out_signature='s')
  def emitStartSignal(self,enginelist):
    self.StartSignal(enginelist)
    print "emitted start signal"
    return 'Signal emitted'

  #Emit Status Signal 
  @dbus.service.signal(dbus_interface='CommonPlatform.Engine.ServiceInterface',signature='s')
  def StatusSignal(self,message):
     print "engine : statusSignal : " + message
     pass

  @dbus.service.method('CommonPlatform.Engine.ServiceInterface',in_signature='s',out_signature='s')
  def emitStatusSignal(self,engineName):
    self.StatusSignal(engineName)
    print "emitted status signal"
    return 'Signal emitted'

 
  #Query Status
  @dbus.service.method("CommonPlatform.Engine.ServiceInterface",
                       in_signature='s',out_signature='as')
  def Status(self,string_param):
    return["Engine", " serivce status - ", "some status", session_bus.get_unique_name()]

  # RaiseException
  @dbus.service.method("CommonPlatform.Engine.ServiceInterface",
                         in_signature='', out_signature='')
  def RaiseException(self):
        raise serviceException('Service Object called service Exception '
                            'expect')
  # Exit
  @dbus.service.method("CommonPlatform.Engine.ServiceInterface",
                         in_signature='', out_signature='')
  def Kill(self):
        mainloop.quit()

  #Start Service
  @dbus.service.method("CommonPlatform.Engine.ServiceInterface",
                       in_signature='s',out_signature='u')
  def Start(self,string_param):
    global enginename
    enginename = str(string_param)
    engine_name = str(string_param) +"Service.xml"
    doc = minidom.parse(engine_name) 
    serviceXML = ServiceOptions(doc)
    #serviceXML.ServiceDebug()
    serviceXML.execute(enginename)
    return int(0)

  #Stop Service
  @dbus.service.method("CommonPlatform.Engine.ServiceInterface",
                       in_signature='s',out_signature='u')
  def Stop(self,string_param):
    stop_process = process_dict[string_param]
    os.kill(stop_process.pid,signal.SIGTERM)
    return int(0)

  #Restart Service
  @dbus.service.method("CommonPlatform.Engine.ServiceInterface",
                       in_signature='s',out_signature='u')
  def Restart(self,string_param):
    print str(string_param)
    return int(0)

if __name__ == '__main__':
    argc =  len(sys.argv)
    if(sys.argv[1:] == ['--help']):
      print "Usage : ./serviceDaemon.py <optional ipaddress>"    
    elif(argc <=3):
      if(argc == 2):
        ipaddress = sys.argv[1]
      dbus.mainloop.glib.DBusGMainLoop(set_as_default=True)

      session_bus = dbus.SessionBus()
      name = dbus.service.BusName("CommonPlatform.Engine.ServiceInterface", session_bus)
      object = Service(session_bus)

      mainloop = gobject.MainLoop()
      print "Running engine service Daemon."
      mainloop.run()
    else:
      print "Usage : ./serviceDaemon.py <optional ipaddress>"
       
