//var globalUi = 0; //THIS CODE IS SOMETIMES USEFUL TO DEBUG USING SCRIPT DEBUG CONSOLE

function Initialize(tile, engine, system)
{
    //print('>AltIndZero::Initialize');

    this.tile = tile;
    this.ui = tile.getContainerFrame();
    this.engine = engine;

    //Connect start alt ind zero button
    this.ui.PushButton_AltIndZeroStart.clicked.connect(this, this.startAltIndZero);

    //Connect abort button
    this.ui.PushButton_AltIndZeroCancel.clicked.connect(this, this.exitAltIndZero);

    this.tile.setWindowTitle("Altitude Indicator Zero");

    var closeBtn = this.tile.findChild("ContainerClose");
    closeBtn.hide();

    this.ui.GroupBox_Instructions.Label_Instructions.setText("This menu provides a simple way to remove any altitude offset from the indicator.\n\nThe output is set up for 0ft and once we lock onto the signal from the Altimeter the indicator should display a value close to zero.\n\nIf the reading is zero foot then you can simply abort out of the zeroing function.\n\nOtherwise, adjust the altitude offset until the indicator reads zero foot and then save.\n\nUpon completion you will be returned to this menu.\n\nPlease set up all settings before running this function otherwise the radio may not lock to 0ft.\n\n\nPlease note that the test set is unable to drive some altimeters all the way to zero foot. For these, do not use the Altimeter Zero Function.\n\n\n\nPress 'Start' to begin altitude indicator zero.");

    //print('<AltIndZero::Initialize');
}

Initialize.prototype.startCalWizard = function(typeIdx)
{
    //print('>AltIndZero::startCalWizard '+typeIdx);

    //triggers initialization of calibration wizard
    calTile = this.engine.getTile("7"); // Calibration wizard
    calWidget = calTile.getContainerFrame();

    try
    {
        calWidget.stackedWidget_hidden.setCurrentIndex(typeIdx);
    }
    catch(e)
    {
        print('UserInterface - AltIndZero::startCalWizard::exception - ' + e);
    }

    calTile.show();//display the calibration wizard screen
    var closeBtn = calTile.findChild("ContainerClose");
    closeBtn.hide();
    //print('<AltIndZero::startCalWizard');
}

Initialize.prototype.startAltIndZero = function()
{
    //print('>AltIndZero::startAltIndZero');

    this.startCalWizard(6); //ALTZERO - number must match getCalIdx() in RA_factoryCalibration.js
    //this.startCalWizard(7); //ALTZERO - number must match getCalIdx() in RA_factoryCalibration.js - tx atten cal added

    //print('<AltIndZero::startAltIndZero');
}

Initialize.prototype.exitAltIndZero = function()
{
    //print('>AltIndZero::exitAltIndZero ' + this.type);

    var screen = this.engine.getTile("3"); //return to test setup menu
    screen.show();
    this.tile.close();

    //print('<AltIndZero::exitAltIndZero');
}
