//var globalUi = 0; //THIS CODE IS SOMETIMES USEFUL TO DEBUG USING SCRIPT DEBUG CONSOLE

var NUM_CALIBRATIONS = 8;         //TCXO, CW_RECEIVE, PULSE_RECEIVE, TX, LOOPBACK, USER, ALTZERO, COIL
var NUM_FACTORY_CALIBRATIONS = 5; //TCXO, CW_RECEIVE, PULSE_RECEIVE, TX, LOOPBACK, COIL
//var NUM_CALIBRATIONS = 8;         //TCXO, CW_RECEIVE, PULSE_RECEIVE, TX, TXATTEN, LOOPBACK, USER, ALTZERO
//var NUM_FACTORY_CALIBRATIONS = 6; //TCXO, CW_RECEIVE, PULSE_RECEIVE, TX, TXATTEN, LOOPBACK

//used to determine when exit from alt ind zero
var prevCalButtonsLocked;
var currentCalButtonsLocked;

//SCRIPT WRITTEN BASED ON CALIBRATION_WIZARD_HELPER_OBJECT OF 05/10/2010
function Initialize(tile, engine, system)
{
    //print('>CalibrationWizard::Initialize');

    this.tile = tile;
    this.ui = tile.getContainerFrame();
    this.engine = engine;

    this.ui.stackedWidget_hidden.hide();
    this.ui.stackedWidget_hidden.setCurrentIndex(this.ui.stackedWidget_hidden.pageNull); //initialize hidden stacked widget index to non-existent so will trigger on restart

    //Connect current page value change (preferred because means engine is done with operations sparked by "Next"
    this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepNum.valueChanged.connect(this, this.advancePage);
    this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepNum.valueChanged.connect(this, this.advancePage);
    this.ui.stackedWidget_cnt.pageCntTx.NumericEntry_TxStepNum.valueChanged.connect(this, this.advancePage);
    this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.valueChanged.connect(this, this.advancePage);
    //this.ui.stackedWidget_cnt.pageCntTxAtten.NumericEntry_TxAttenStepNum.valueChanged.connect(this, this.advancePage);

    //Connect abort & finish buttons
    this.ui.PushButton_Abort.clicked.connect(this, this.cancelWizard);
    this.ui.stackedWidget_btn.pageBtnAltZero.PushButton_AltZeroAbort.clicked.connect(this, this.cancelWizard);

    this.ui.stackedWidget_btn.pageBtnTcxo.PushButton_FinishTcxo.clicked.connect(this, this.finishWizard);
    this.ui.stackedWidget_btn.pageBtnRxCW.PushButton_FinishRxCW.clicked.connect(this, this.finishWizard);
    this.ui.stackedWidget_btn.pageBtnRFDM.PushButton_FinishRFDM.clicked.connect(this, this.finishWizard);
    this.ui.stackedWidget_btn.pageBtnRxPulse.PushButton_FinishRxPulse.clicked.connect(this, this.finishWizard);
    this.ui.stackedWidget_btn.pageBtnTx.PushButton_FinishTx.clicked.connect(this, this.finishWizard);
    //this.ui.stackedWidget_btn.pageBtnTxAtten.PushButton_FinishTxAtten.clicked.connect(this, this.finishWizard);
    this.ui.stackedWidget_hidden.pageHiddenUser.FlagStatus_UserRunning.changeState.connect(this, this.userRunningChanged);
    this.ui.stackedWidget_hidden.pageHiddenLoopback.FlagStatus_FactoryCalRunning.changeState.connect(this, this.factoryCalRunningChanged);

    this.ui.stackedWidget_btn.pageBtnAltZero.PushButton_AltZeroFinish.clicked.connect(this, this.finishWizard);

    //Initialize stacked widgets and fields
    this.ui.stackedWidget_hidden.currentChanged.connect(this, this.ui.stackedWidget_cnt.setCurrentIndex);
    this.ui.stackedWidget_hidden.currentChanged.connect(this, this.ui.stackedWidget_btn.setCurrentIndex);
    this.ui.stackedWidget_hidden.currentChanged.connect(this, this.ui.GroupBox_Instructions.stackedWidget_val.setCurrentIndex);
    this.ui.stackedWidget_hidden.currentChanged.connect(this, this.initializeWizard);

    this.ui.stackedWidget_hidden.setCurrentWidget(this.ui.stackedWidget_hidden.pageNull);

    //hide and connect the cal buttons locked attribute
    this.ui.stackedWidget_hidden.pageHiddenAltZero.NumericEntry_CalButtonsLocked.hide();//read only status attribute so don't show on the screen
    this.ui.stackedWidget_hidden.pageHiddenAltZero.NumericEntry_CalButtonsLocked.valueChanged.connect(this, this.calRunningChange);

    prevCalButtonsLocked = 0;
    currentCalButtonsLocked = 0;

    //print('<CalibrationWizard::Initialize');
}

Initialize.prototype.calRunningChange = function()
{
    //print('>CalibrationWizard::calRunningChange');
    var lockedReason = this.ui.stackedWidget_hidden.pageHiddenAltZero.NumericEntry_CalButtonsLocked.getValue();

    //print(' CalibrationWizard::calRunningChange  '+lockedReason);

    prevCalButtonsLocked = currentCalButtonsLocked;
    currentCalButtonsLocked = lockedReason;

    //print(' CalibrationWizard::calRunningChange  prev='+prevCalButtonsLocked+', current='+currentCalButtonsLocked);

    if ((currentCalButtonsLocked == 0) && (prevCalButtonsLocked == 14))
    {
        //print(' CalibrationWizard::calRunningChange  Changing screen');

        calTile = this.engine.getTile("7"); // Calibration wizard/Alt Ind Zero
        if (calTile.isVisible())//if on alt ind zero screen (actually calibration wizard)
        {
            var screen = this.engine.getTile("9"); //return to alt ind zero info menu
            screen.show();
            calTile.close();
        }
    }

    //print('<CalibrationWizard::calRunningChange');
}

Initialize.prototype.initializeWizard = function(calIdx)
{
    //print('>CalibrationWizard::initializeWizard - ' + calIdx + ' / ' + NUM_CALIBRATIONS);

    if(calIdx < NUM_CALIBRATIONS)
    {
	    this.type = calIdx;
	    this.successful = false;
	    this.currentPage = 1;

	    this.setupWindow();
	    this.setButtonVisibility();
	    this.setValueVisibility();
	    this.setPageText();
	}

	//if(7 == calIdx) //Alt. Indicator Zero (with new Tx Atten cal)
	if(6 == calIdx) //Alt. Indicator Zero
	{
	    this.ui.GroupBox_Instructions.stackedWidget_val.pageValAltZero.CustomWidget_NumericSlewEntry_AltOffset.setPrecision(1);
	}

    //print('<CalibrationWizard::initializeWizard');
}

Initialize.prototype.advancePage = function()
{
    //print('>CalibrationWizard::AdvancePage');
    this.currentPage = this.currentPage + 1;
    //print(' CalibrationWizard::AdvancePage: to '+this.currentPage);
    this.setButtonVisibility();
    this.setValueVisibility();
    this.setPageText();
    //print('<CalibrationWizard::AdvancePage');
}

Initialize.prototype.cancelWizard = function()
{
    //print('>CalibrationWizard::cancelWizard ' + this.type);

    //only move back to previous screen if we are on the correct screen
    //if the user has changed screens while the cal is running then do not change the screen when the cal aborts

    //if(7 == this.type) //Alt. Indicator Zero (with new Tx Atten cal)
    if(6 == this.type) //Alt. Indicator Zero
    {
        if (this.tile.isVisible())//if on alt ind zero screen (actually calibration wizard)
        {
            var screen = this.engine.getTile("9"); //return to alt ind zero info menu
            screen.show();
            this.tile.close();
        }
    }
    //else if(6 == this.type) //User (Delay) Cal (with new Tx Atten cal)
    else if(5 == this.type) //User (Delay) Cal
    {
        if (this.tile.isVisible())//if on user (delay) cal screen (actually calibration wizard)
        {
            var screen = this.engine.getTile("5"); //return to user delay cal menu
            screen.show();
            this.tile.close();
        }
    }
    else //factory calibrations
    {
        if (this.tile.isVisible())//if on the factory wizard screen
        {
            var screen = this.engine.getTile("6"); //return to factory calibration menu
            screen.show();
            this.tile.close();
        }
    }

    this.ui.stackedWidget_hidden.setCurrentWidget(this.ui.stackedWidget_hidden.pageNull); //reset hidden stacked widget index to non-existent so will trigger on restart
    //print('<CalibrationWizard::cancelWizard');
}

Initialize.prototype.finishWizard = function()
{
    //print('>CalibrationWizard::finishWizard ' + this.type);

    //only move back to previous screen if we are on the correct screen
    //if the user has changed screens while the cal is running then do not change the screen when the cal aborts

    //if(7 == this.type) //Alt. Indicator Zero (with new Tx Atten cal)
    if(6 == this.type) //Alt. Indicator Zero
    {
        if (this.tile.isVisible())//if on alt ind zero screen (actually calibration wizard)
        {
            var screen = this.engine.getTile("9"); //return to alt ind zero info menu
            screen.show();
            this.tile.close();
        }
    }
    //else if(6 == this.type) //User (Delay) Cal (with new Tx Atten cal)
    else if(5 == this.type) //User (Delay) Cal
    {
        if (this.tile.isVisible())//if on user (delay) cal screen (actually calibration wizard)
        {
            var screen = this.engine.getTile("5"); //return to user delay cal menu
            screen.show();
            this.tile.close();
        }
    }
    else //factory calibrations
    {
        if (this.tile.isVisible())//if on the factory wizard screen
        {
            var screen = this.engine.getTile("6"); //return to factory calibration menu
            screen.show();
            this.tile.close();
        }
    }

    this.ui.stackedWidget_hidden.setCurrentWidget(this.ui.stackedWidget_hidden.pageNull); //reset hidden stacked widget index to non-existent so will trigger on restart
    //print('<CalibrationWizard::finishWizard');
}

Initialize.prototype.userRunningChanged = function(userRunningState)
{
    //print('>CalibrationWizard::userRunningChanged: '+userRunningState);

    if ("Normal" == userRunningState)//cal finished
    {
        this.successful = true;
        this.finishWizard();
    }
    //print('<CalibrationWizard::userRunningChanged');
}

Initialize.prototype.factoryCalRunningChanged = function(factoryCalRunningState)
{
    //print('>CalibrationWizard::factoryCalRunningChanged: '+factoryCalRunningState);

    if ("Normal" == factoryCalRunningState)//cal finished
    {
        //if (this.type == 5) //analog atten cal/loopback cal (with new tx atten cal)
        if (this.type == 4) //analog atten cal/loopback cal
        {
            //print(' CalibrationWizard::factoryCalRunningChanged: finishing loopback cal');
            this.successful = true;
            this.finishWizard();
        }
    }
    //print('<CalibrationWizard::factoryCalRunningChanged');
}

Initialize.prototype.setupWindow = function()
{
    //print('>CalibrationWizard::setupWindow');

    this.tile.setWindowTitle(this.getCalTitle(this.type));

    //if((this.type < NUM_FACTORY_CALIBRATIONS) || (this.type == 6)) // is factory calibration or user delay calibration (with new tx atten cal)
    if((this.type != 6)) // is factory calibration or user delay calibration, just not Alt Indicator Zero
    {
        //print(' CalibrationWizard::setupWindow - hide the close button');
        var closeBtn = this.tile.findChild("ContainerClose");
        closeBtn.hide();
    }
    //print('<CalibrationWizard::setupWindow');
}

Initialize.prototype.setButtonVisibility = function()
{
    //print('>CalibrationWizard::setButtonVisibility '+this.type);
    switch(this.type)
    {
    case 0: //TCXO
        //print(' CalibrationWizard::setButtonVisibility(Tcxo) - DoNothing');
        this.ui.PushButton_Abort.show();
        //1 page, never hide buttons
        break;
    case 1: // CW_RECEIVE
        //print(this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepNum.getValue()+'?='+this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepTotal.getValue());
        this.ui.PushButton_Abort.show();
        if(1 == this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepNum.getValue())
        {
            //print(' CalibrationWizard::setButtonVisibility(RxCW) - 1st page');
            this.ui.stackedWidget_btn.pageBtnRxCW.PushButton_BackRxCW.hide();
            this.ui.stackedWidget_btn.pageBtnRxCW.PushButton_NextRxCW.show();
            this.ui.stackedWidget_btn.pageBtnRxCW.PushButton_FinishRxCW.hide();
        }
        else if(this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepTotal.getValue())
        {
            //print(' CalibrationWizard::setButtonVisibility(RxCW) - HideNext,ShowFinish');
            this.ui.stackedWidget_btn.pageBtnRxCW.PushButton_NextRxCW.hide();
            this.ui.stackedWidget_btn.pageBtnRxCW.PushButton_FinishRxCW.show();
        }
        else
        {
            //print(' CalibrationWizard::setButtonVisibility(RxCW) - ShowNext,HideFinish');
            //this.ui.stackedWidget_btn.pageBtnRxCW.PushButton_BackRxCW.show();//temporarily remove until engine can handle back button
            this.ui.stackedWidget_btn.pageBtnRxCW.PushButton_NextRxCW.show();
            this.ui.stackedWidget_btn.pageBtnRxCW.PushButton_FinishRxCW.hide();
        }
        break;
    case 2: // PULSE_RECEIVE
        //print(this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepNum.getValue()+'?='+this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepTotal.getValue());
        this.ui.PushButton_Abort.show();
        if(1 == this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepNum.getValue())
        {
            //print(' CalibrationWizard::setButtonVisibility(RxPulse) - 1st page');
            this.ui.stackedWidget_btn.pageBtnRxPulse.PushButton_BackRxPulse.hide();
            this.ui.stackedWidget_btn.pageBtnRxPulse.PushButton_NextRxPulse.show();
            this.ui.stackedWidget_btn.pageBtnRxPulse.PushButton_FinishRxPulse.hide();
        }
        else if(this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepTotal.getValue())
        {
            //print(' CalibrationWizard::setButtonVisibility(RxPulse) - HideNext,ShowFinish');
            //this.ui.stackedWidget_btn.pageBtnRxPulse.PushButton_BackRxPulse.show();//temporarily remove until engine can handle back button
            this.ui.stackedWidget_btn.pageBtnRxPulse.PushButton_NextRxPulse.hide();
            this.ui.stackedWidget_btn.pageBtnRxPulse.PushButton_FinishRxPulse.show();
        }
        else
        {
            //print(' CalibrationWizard::setButtonVisibility(RxPulse) - ShowNext,HideFinish');
            //this.ui.stackedWidget_btn.pageBtnRxPulse.PushButton_BackRxPulse.show();//temporarily remove until engine can handle back button
            this.ui.stackedWidget_btn.pageBtnRxPulse.PushButton_NextRxPulse.show();
            this.ui.stackedWidget_btn.pageBtnRxPulse.PushButton_FinishRxPulse.hide();
        }
        break;
    case 3: // TX
        //print(this.ui.stackedWidget_cnt.pageCntTx.NumericEntry_TxStepNum.getValue()+'?='+this.ui.stackedWidget_cnt.pageCntTx.NumericEntry_TxStepTotal.getValue());
        this.ui.PushButton_Abort.show();
        if(1 == this.ui.stackedWidget_cnt.pageCntTx.NumericEntry_TxStepNum.getValue())
        {
            //print(' CalibrationWizard::setButtonVisibility(Tx) - 1st page');
            this.ui.stackedWidget_btn.pageBtnTx.PushButton_BackTx.hide();
            this.ui.stackedWidget_btn.pageBtnTx.PushButton_NextTx.show();
            this.ui.stackedWidget_btn.pageBtnTx.PushButton_FinishTx.hide();
        }
        else if(this.ui.stackedWidget_cnt.pageCntTx.NumericEntry_TxStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntTx.NumericEntry_TxStepTotal.getValue())
        {
            //print(' CalibrationWizard::setButtonVisibility(Tx) - HideNext,ShowFinish');
            //this.ui.stackedWidget_btn.pageBtnTx.PushButton_BackTx.show();//temporarily remove until engine can handle back button
            this.ui.stackedWidget_btn.pageBtnTx.PushButton_NextTx.hide();
            this.ui.stackedWidget_btn.pageBtnTx.PushButton_FinishTx.show();
        }
        else
        {
            //print(' CalibrationWizard::setButtonVisibility(Tx) - ShowNext,HideFinish');
            //this.ui.stackedWidget_btn.pageBtnTx.PushButton_BackTx.show();//temporarily remove until engine can handle back button
            this.ui.stackedWidget_btn.pageBtnTx.PushButton_NextTx.show();
            this.ui.stackedWidget_btn.pageBtnTx.PushButton_FinishTx.hide();
        }
        break;
/*
    case 4: // TX Atten
        //print(this.ui.stackedWidget_cnt.pageCntTxAtten.NumericEntry_TxAttenStepNum.getValue()+'?='+this.ui.stackedWidget_cnt.pageCntTxAtten.NumericEntry_TxAttenStepTotal.getValue());
        this.ui.PushButton_Abort.show();
        if(1 == this.ui.stackedWidget_cnt.pageCntTxAtten.NumericEntry_TxAttenStepNum.getValue())
        {
            //print(' CalibrationWizard::setButtonVisibility(TxAtten) - 1st page');
            this.ui.stackedWidget_btn.pageBtnTxAtten.PushButton_BackTxAtten.hide();
            this.ui.stackedWidget_btn.pageBtnTxAtten.PushButton_NextTxAtten.show();
            this.ui.stackedWidget_btn.pageBtnTxAtten.PushButton_FinishTxAtten.hide();
        }
        else if(this.ui.stackedWidget_cnt.pageCntTxAtten.NumericEntry_TxAttenStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntTxAtten.NumericEntry_TxAttenStepTotal.getValue())
        {
            //print(' CalibrationWizard::setButtonVisibility(TxAtten) - HideNext,ShowFinish');
            //this.ui.stackedWidget_btn.pageBtnTxAtten.PushButton_BackTxAtten.show();//temporarily remove until engine can handle back button
            this.ui.stackedWidget_btn.pageBtnTxAtten.PushButton_NextTxAtten.hide();
            this.ui.stackedWidget_btn.pageBtnTxAtten.PushButton_FinishTxAtten.show();
        }
        else
        {
            //print(' CalibrationWizard::setButtonVisibility(TxAtten) - ShowNext,HideFinish');
            //this.ui.stackedWidget_btn.pageBtnTxAtten.PushButton_BackTxAtten.show();//temporarily remove until engine can handle back button
            this.ui.stackedWidget_btn.pageBtnTxAtten.PushButton_NextTxAtten.show();
            this.ui.stackedWidget_btn.pageBtnTxAtten.PushButton_FinishTxAtten.hide();
        }
        break;
*/
    //case 5: //LOOPBACK (with new tx atten cal)
    case 4: //LOOPBACK
        //print(' CalibrationWizard::setButtonVisibility(Loopback) - DoNothing');
        //Not sure I have this right yet TO DO
        this.ui.PushButton_Abort.show();
        //1 page, never hide buttons
        break;
    //case 6: // USER (with new tx atten cal)
    case 5: // USER
        //print(' CalibrationWizard::setButtonVisibility(User) - DoNothing');
        this.ui.PushButton_Abort.hide();
        //1 page, never hide buttons
        break;
    //case 7: //ALTZERO (with new tx atten cal)
    case 6: //ALTZERO
        //print(' CalibrationWizard::setButtonVisibility(AltZero) - DoNothing');
        this.ui.PushButton_Abort.hide();
        //1 page, never hide buttons
        break;
    case 7: //CoilCal
        //print(' CalibrationWizard::setButtonVisibility(CoilCal) - DoNothing');
        //Not sure I have this right yet TO DO
        this.ui.PushButton_Abort.show();
        if(1 == this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue())
        {
            //print(' CalibrationWizard::setButtonVisibility(RFDM) - 1st page');
            this.ui.stackedWidget_btn.pageBtnRFDM.PushButton_BackRFDM.hide();
            this.ui.stackedWidget_btn.pageBtnRFDM.PushButton_NextRFDM.show();
            this.ui.stackedWidget_btn.pageBtnRFDM.PushButton_FinishRFDM.hide();
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 15)
              //  this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepTotal.getValue())
        {
            //print(' CalibrationWizard::setButtonVisibility(RFDM) - HideNext,ShowFinish');
            //this.ui.stackedWidget_btn.pageBtnRFDM.PushButton_BackRFDM.show();//temporarily remove until engine can handle back button
            this.ui.stackedWidget_btn.pageBtnRFDM.PushButton_NextRFDM.hide();
            this.ui.stackedWidget_btn.pageBtnRFDM.PushButton_FinishRFDM.show();
        }
        else
        {
            //print(' CalibrationWizard::setButtonVisibility(RFDM) - ShowNext,HideFinish');
            //this.ui.stackedWidget_btn.pageBtnRFDM.PushButton_BackRFDM.show();//temporarily remove until engine can handle back button
            this.ui.stackedWidget_btn.pageBtnRFDM.PushButton_NextRFDM.show();
            this.ui.stackedWidget_btn.pageBtnRFDM.PushButton_FinishRFDM.hide();
        }
        break;
    }
    //print('<CalibrationWizard::setButtonVisibility');
}

Initialize.prototype.setValueVisibility = function()
{
    //print('>CalibrationWizard::setValueVisibility '+this.type);
    switch(this.type)
    {
    case 0: //TCXO
        //print(' CalibrationWizard::setValueVisibility(Tcxo) - NoHide');
        //1 page, never hide value
        break;
    case 1: // CW_RECEIVE
        if(this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepTotal.getValue())
        {
            //print(' CalibrationWizard::setValueVisibility(RxCW) - HideValue');
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValRxCW.NumericEntry_RxCWValue.hide();
        }
        else
        {
            //print(' CalibrationWizard::setValueVisibility(RxCW) - ShowValue');
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValRxCW.NumericEntry_RxCWValue.show();
        }
        break;
    case 2: // PULSE_RECEIVE
        if(this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepTotal.getValue())
        {
            //print(' CalibrationWizard::setValueVisibility(RxPulse) - HideValue');
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValRxPulse.NumericEntry_RxPulseValue.hide();
        }
        else
        {
            //print(' CalibrationWizard::setValueVisibility(RxPulse) - ShowValue');
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValRxPulse.NumericEntry_RxPulseValue.show();
        }
        break;
    case 3: // TX
        if(this.ui.stackedWidget_cnt.pageCntTx.NumericEntry_TxStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntTx.NumericEntry_TxStepTotal.getValue())
        {
            //print(' CalibrationWizard::setValueVisibility(Tx) - HideTx,HideRx');
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValTx.NumericEntry_TxValueTx.hide();
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValTx.NumericEntry_TxValueRx.hide();
        }
        else
        {
            if(this.ui.stackedWidget_hidden.pageHiddenTx.FlagStatus_TxAttenIsTx.getState() == "Tripped")
            {
                //print(' CalibrationWizard::setValueVisibility(Tx) - ShowTx,HideRx');
                this.ui.GroupBox_Instructions.stackedWidget_val.pageValTx.NumericEntry_TxValueTx.show();
                this.ui.GroupBox_Instructions.stackedWidget_val.pageValTx.NumericEntry_TxValueRx.hide();
            }
            else
            {
                //print(' CalibrationWizard::setValueVisibility(Tx) - HideTx,ShowRx');
                this.ui.GroupBox_Instructions.stackedWidget_val.pageValTx.NumericEntry_TxValueTx.hide();
                this.ui.GroupBox_Instructions.stackedWidget_val.pageValTx.NumericEntry_TxValueRx.show();
            }
        }
        break;
/*
    case 4: // TX Atten
        if(this.ui.stackedWidget_cnt.pageCntTxAtten.NumericEntry_TxAttenStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntTxAtten.NumericEntry_TxAttenStepTotal.getValue())
        {
            //print(' CalibrationWizard::setValueVisibility(TxAtten) - HideTx');
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValTxAtten.NumericEntry_TxAttenValue.hide();
        }
        else
        {
            //print(' CalibrationWizard::setValueVisibility(TxAtten) - ShowTx');
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValTxAtten.NumericEntry_TxAttenValue.show();
        }
        break;
*/
    //case 5: //LOOPBACK (with new tx atten cal)
    case 4: //LOOPBACK
        //print(' CalibrationWizard::setValueVisibility(Loopback) - NoHide');
        //Not sure I have this right yet TO DO
        //1 page, never hide value
        break;
    //case 6: // USER (with new tx atten cal)
    case 5: // USER
        //print(' CalibrationWizard::setValueVisibility(User) - NoHide');
        //1 page, never hide value
        //if(this.currentPage == 1)
        //{
        //    //print(' CalibrationWizard::setValueVisibility(User) - ShowValue Idle, HideValue Running');
        //    this.ui.GroupBox_Instructions.stackedWidget_val.pageValUser.NumericEntry_UserValue.hide();
        //    this.ui.GroupBox_Instructions.stackedWidget_val.pageValUser.NumericEntry_UserFM.show();
        //    this.ui.GroupBox_Instructions.stackedWidget_val.pageValUser.NumericEntry_UserPulse.show();
        //}
        //else
        //{
        //    //print(' CalibrationWizard::setValueVisibility(User) - HideValue Idle, ShowValue Running');
        //    this.ui.GroupBox_Instructions.stackedWidget_val.pageValUser.NumericEntry_UserFM.hide();
        //    this.ui.GroupBox_Instructions.stackedWidget_val.pageValUser.NumericEntry_UserPulse.hide();
        //    this.ui.GroupBox_Instructions.stackedWidget_val.pageValUser.NumericEntry_UserValue.show();
        //}
        break;
    //case 7: //ALTZERO (with new tx atten cal)
    case 6: //ALTZERO
        //print(' CalibrationWizard::setValueVisibility(AltZero) - NoHide');
        //1 page, never hide value
        break;
    case 7: //CoilCal
        if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepTotal.getValue())
        {
            //print(' CalibrationWizard::setValueVisibility(RFDM) - HideLoss,HideDelay');
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValRFDM.NumericEntry_RFDMValue1.hide();
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValRFDM.NumericEntry_RFDMValue2.hide();
        }
        else
        {
            //print(' CalibrationWizard::setValueVisibility(RFDM) - ShowLoss,ShowDelay');
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValRFDM.NumericEntry_RFDMValue1.show();
            this.ui.GroupBox_Instructions.stackedWidget_val.pageValRFDM.NumericEntry_RFDMValue2.show();
        }
        break;
    }
    //print('<CalibrationWizard::setValueVisibility');
}

Initialize.prototype.setPageText = function()
{
    //print('>CalibrationWizard::setPageText '+this.type);
    switch(this.type)
    {
    case 0: //TCXO
        if(this.currentPage == 1)
        {
            //print(' CalibrationWizard::setPageText(Tcxo) - 1page');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Connect frequency counter to RF Out port.\n\nAdjust value to give 4300 MHz.");
        }
        break;
    case 1: // CW_RECEIVE
        if(this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepTotal.getValue())
        {
            //print(' CalibrationWizard::setPageText(RxCW) - last page');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Calibration data acquired.\n\nTo save calibration data, press \"Save & Return\".");
        }
        else
        {
            //print(' CalibrationWizard::setPageText(RxCW) - page' + this.ui.stackedWidget_cnt.pageCntRxCW.NumericEntry_RxCWStepNum.getValue());
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Connect the CW signal generator to the RF In port.\n\nSetup to give " +
                    this.ui.stackedWidget_hidden.pageHiddenRxCW.NumericEntry_RxCwFrequency.getValue() + " MHz with a power level of " +
                    this.ui.stackedWidget_hidden.pageHiddenRxCW.NumericEntry_RxCwPwrLevel.getValue() + " dBm at RF In port.");
        }
        break;
    case 2: // PULSE_RECEIVE
        if(this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepTotal.getValue())
        {
            //print(' CalibrationWizard::setPageText(RxPulse) - lastPage');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Calibration data acquired.\n\nTo save calibration data, press \"Save & Return\".");
        }
        else
        {
            if(this.ui.stackedWidget_hidden.pageHiddenRxPulse.NumericEntry_RxPulsePulseWidth.getValue() == "0")
            {
                //print(' CalibrationWizard::setPageText(RxPulse) - page' + this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepNum.getValue() + '; zero pulse width');
                this.ui.GroupBox_Instructions.Label_Instructions.setText("Turn off the RF on the signal generator.");
            }
            else
            {
                //print(' CalibrationWizard::setPageText(RxPulse) - page' + this.ui.stackedWidget_cnt.pageCntRxPulse.NumericEntry_RxPulseStepNum.getValue() + '; pulse width = ' + this.ui.stackedWidget_hidden.pageHiddenRxPulse.NumericEntry_RxPulsePulseWidth.getValue());
                this.ui.GroupBox_Instructions.Label_Instructions.setText("Connect the pulse signal generator to the RF In port.\n\n" +
                        "Setup the signal generator for 4300 MHz at 10 dBm at the RF In port.\n\n" +
                        "Setup pulse modulation for " +
                        this.ui.stackedWidget_hidden.pageHiddenRxPulse.NumericEntry_RxPulsePulseWidth.getValue() +
                        " ns wide pulses with a PRF of 10 kHz.");
            }
        }
        break;
    case 3: // TX
        //print(' CalibrationWizard::setPageText(Tx)');
        if(this.ui.stackedWidget_cnt.pageCntTx.NumericEntry_TxStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntTx.NumericEntry_TxStepTotal.getValue())
        {
            //print(' CalibrationWizard::setPageText(Tx) - lastPage');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Calibration data acquired.\n\nTo save calibration data, press \"Save & Return\".");
        }
        else if(this.ui.stackedWidget_hidden.pageHiddenTx.FlagStatus_TxUseSiggen.getState() == "Tripped")
        {
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Connect CW SigGen to RF In port and set to give " +
                    this.ui.stackedWidget_hidden.pageHiddenTx.NumericEntry_TxFrequency.getValue() +
                    " MHz, 0 dBm at RF In port.\n\nAdjust value for exactly " +
                    this.ui.stackedWidget_hidden.pageHiddenTx.NumericEntry_TxPwrLevel.getValue() +
                    " dBm at " +
                    this.ui.stackedWidget_hidden.pageHiddenTx.NumericEntry_TxFrequency.getValue() +
                    " MHz at RF Out port.");
        }
        else
        {
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Adjust value for exactly " +
                    this.ui.stackedWidget_hidden.pageHiddenTx.NumericEntry_TxPwrLevel.getValue() +
                    " dBm at " +
                    this.ui.stackedWidget_hidden.pageHiddenTx.NumericEntry_TxFrequency.getValue() +
                    " MHz at RF Out port.");
        }
        break;
/*
    case 4: // TX Atten
        //print(' CalibrationWizard::setPageText(TxAtten)');
        if(this.ui.stackedWidget_cnt.pageCntTxAtten.NumericEntry_TxAttenStepNum.getValue() ==
                this.ui.stackedWidget_cnt.pageCntTxAtten.NumericEntry_TxAttenStepTotal.getValue())
        {
            //print(' CalibrationWizard::setPageText(TxAtten) - lastPage');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Calibration data acquired.\n\nTo save calibration data, press \"Save & Return\".");
        }
        else
        {
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Adjust value for exactly " +
                    this.ui.stackedWidget_hidden.pageHiddenTxAtten.NumericEntry_TxAttenPwrLevel.getValue() +
                    " dBm at 4300 MHz at RF Out port.");
        }
        break;
*/
    //case 5: //LOOPBACK (with new tx atten cal)
    case 4: //LOOPBACK
        if(this.currentPage == 1)
        {
            //print(' CalibrationWizard::setPageText(Loopback) - 1page');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Calibrating Analog Attenuators and Pulse Measurement Circuit.\n\nPlease wait until calibration completes.");
            //Not sure I have this right yet TO DO
        }
        break;
    //case 6: // USER (with new tx atten cal)
    case 5: // USER
        //print(' CalibrationWizard::setPageText(User)');
        this.ui.GroupBox_Instructions.Label_Instructions.setText("Calibrating cables.\n\nThis calibration cannot be aborted once it has been started.\n\nPlease wait until calibration completes.");
        break;
    //case 7: //ALTZERO (with new tx atten cal)
    case 6: //ALTZERO
        if(this.currentPage == 1)
        {
            //print(' CalibrationWizard::setPageText(AltZero) - 1page');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Wait until the status indicates a valid signal then adjust the Altitude Offset field\nuntil 0 ft is displayed on the aircraft altitude indicator.\n\nSelect Save & Return to store the entered value and return to the previous screen.\n\nIf you have not performed a Delay Calibration then abort the Altitude Indicator Zero\nand perform the Delay Calibration before returning to this screen.\n\nIf manual uut detect mode is selected and the uut mode is set incorrectly,\nthe Altitude Indicator Zero may fail to detect the Altimeter.");
        }
        break;
    case 7: //CoilCal
        // if(this.currentPage == 1)
        // {
        //     //print(' CalibrationWizard::setPageText(CoilCal) - 1page');
        //     this.ui.GroupBox_Instructions.Label_Instructions.setText("Calibrating RF and Fiber Coils.\n\nPlease wait until calibration completes.");
        //     //Not sure I have this right yet TO DO
        // }
        //print(' CalibrationWizard::setPageText(CoilCal)');
        if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 15)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - lastPage');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Calibration data acquired." +
            "\n\nTo save calibration data, press \"Save & Return\".");
        }
        else if (this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 1)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 1');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for \"No RF Coils\" "
            + "switched in.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 2)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 2');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 5 "
            + "foot RF Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 3)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 3');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 10 "
            + "foot RF Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 4)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 4');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 20 "
            + "foot RF Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 5)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 5');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for No Fiber Coils."
            + "\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 6)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 6');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 40 "
            + "foot Fiber Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 7)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 7');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 80 "
            + "foot Fiber Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 8)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 8');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 160 "
            + "foot Fiber Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 9)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 9');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 320 "
            + "foot Fiber Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 10)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 10');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 640 "
            + "foot Fiber Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 11)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 11');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 1280 "
            + "foot Fiber Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 12)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 12');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 2560 "
            + "foot Fiber Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 13)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 13');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 5120 "
            + "foot Fiber Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        else if(this.ui.stackedWidget_cnt.pageCntRFDM.NumericEntry_RFDMStepNum.getValue() == 14)
        {
            //print(' CalibrationWizard::setPageText(CoilCal) - Step Page 14');
            this.ui.GroupBox_Instructions.Label_Instructions.setText("Enter Coil "
            + "Delay and Coil Loss readings from the Network Analyzer for the 15000 "
            + "foot Fiber Coil.\n\nPress \"Next\" to proceed to the next step.");
        }
        break;
    }
    //print('<CalibrationWizard::setPageText');
}

Initialize.prototype.getCalType = function(idx)
{
    //print('>CalibrationWizard::getCalType '+idx);
    var calStr;

    switch(idx) {
    case 0: //TCXO
        calStr = "Tcxo";
        break;
    case 1: //CW_RECEIVE
        calStr = "CwReceive";
        break;
    case 2: //PULSE_RECEIVE
        calStr = "PulseReceive";
        break;
    case 3: //TX
        calStr = "Tx";
        break;
/*
    case 4: //TX Atten
        calStr = "TxAtten";
        break;
*/
    //case 5: //LOOPBACK (with new tx atten cal)
    case 4: //LOOPBACK
        calStr = "Loopback";
        break;
    //case 6: //USER (with new tx atten cal)
    case 5: //USER
        calStr = "User";
        break;
    //case 7: //ALTZERO (with new tx atten cal)
    case 6: //ALTZERO
        calStr = "AltZero";
        break;
    case 7: //CoilCal
        calStr = "CoilCal";
        break;
    }

    //print('<CalibrationWizard::getCalType returns ' + calStr);
    return calStr;
}

Initialize.prototype.getCalTitle = function(calIdx)
{
    var calTitle;

    //print('>CalibrationWizard::getCalTitle '+calIdx);
    switch(calIdx) {
    case 0: //TCXO
        calTitle = "TCXO Calibration";
        break;
    case 1: //CW_RECEIVE
        calTitle = "Rx CW Calibration";
        break;
    case 2: //PULSE_RECEIVE
        calTitle = "Rx Pulse Calibration";
        break;
    case 3: //TX
        calTitle = "Tx Calibration";
        break;
/*
    case 4: //TX Atten
        calTitle = "Tx Atten Calibration";
        break;
*/
    //case 5: //LOOPBACK (with new tx atten cal)
    case 4: //LOOPBACK
        calTitle = "Loopback Calibration";
        break;
    //case 6: //USER (with new tx atten cal)
    case 5: //USER
        calTitle = "User Delay Calibration";
        break;
    //case 7: //ALTZERO (with new tx atten cal)
    case 6: //ALTZERO
        calTitle = "Altitude Indicator Zero";
        break;
    case 7: //CoilCal
        calTitle = "RFDM Calibration";
        break;
    }

    //print('<CalibrationWizard::getCalTitle returns ' + calTitle);
    return calTitle;
}
