//var globalUi = 0; //THIS CODE IS SOMETIMES USEFUL TO DEBUG USING SCRIPT DEBUG CONSOLE

function Initialize(tile, engine, system)
{
    //print('>DelayCalData::Initialize');

    this.tile = tile;
    this.ui = tile.getContainerFrame();
    this.engine = engine;

    this.ui.NumericEntry_CalButtonsLocked.hide();//read only status attribute so don't show on the screen

    //Connect start cal button
    this.ui.PushButton_UserStart.clicked.connect(this, this.startDelayCal);

    //Connect abort button
    this.ui.PushButton_UserCancel.clicked.connect(this, this.exitDelayCalResults);

    //Initialize widgets and fields
    this.ui.GroupBox_Instructions.NumericEntry_UserFM.setPrecision(0);
    this.ui.GroupBox_Instructions.NumericEntry_UserPulse.setPrecision(0);

    this.tile.setWindowTitle("User Delay Calibration");

    var closeBtn = this.tile.findChild("ContainerClose");
    closeBtn.hide();

    this.ui.GroupBox_Instructions.Label_Instructions.setText("Connect the Tx and Rx cable ends using the supplied TNC adapter to provide a loopback path between RF In and RF Out ports.\n\nRemove any attenuators that may be attached to the cables.\n\nCalibration cannot be aborted once it has been started.\n\nUpon completion you will be returned to this menu.\n\n\n\nPress 'Start' to begin calibration.");

    //print('<DelayCalData::Initialize');
}

Initialize.prototype.startCalWizard = function(typeIdx)
{
    //print('>DelayCalData::startCalWizard '+typeIdx);

    //triggers initialization of calibration wizard
    calTile = this.engine.getTile("7"); // Calibration wizard
    calWidget = calTile.getContainerFrame();

    try
    {
        calWidget.stackedWidget_hidden.setCurrentIndex(typeIdx);
    }
    catch(e)
    {
        print('UserInterface - DelayCalData::startCalWizard::exception - ' + e);
    }

    calTile.show();//display the calibration wizard screen
    //print('<DelayCalData::startCalWizard');
}

Initialize.prototype.startDelayCal = function()
{
    //print('DelayCalData::startDelayCal');

    this.startCalWizard(5); //USER - number must match getCalIdx() in RA_factoryCalibration.js
    //this.startCalWizard(6); //USER - number must match getCalIdx() in RA_factoryCalibration.js - tx atten cal added
}

Initialize.prototype.exitDelayCalResults = function()
{
    //print('>DelayCalData::exitDelayCalResults ' + this.type);

    var screen = this.engine.getTile("3"); //return to test setup menu
    screen.show();
    this.tile.close();

    //print('<DelayCalData::exitDelayCalResults');
}
