//var globalUi = 0; //THIS CODE IS SOMETIMES USEFUL TO DEBUG USING SCRIPT DEBUG CONSOLE

function Initialize(tile, engine, system)
{
    //print('FactoryCalibration::Initialize entry');

    this.tile = tile;
    this.ui = tile.getContainerFrame();
    this.engine = engine;
    this.system = system;

    this.TCXO     = this.ui.Tab.widget(0);
    this.RxCW     = this.ui.Tab.widget(1);
    this.RxPulse  = this.ui.Tab.widget(2);
    this.TxPower  = this.ui.Tab.widget(3);
    this.Loopback = this.ui.Tab.widget(4);
    this.RFDMCal  = this.ui.Tab.widget(5);
    //this.TxAtten  = this.ui.Tab.widget(4);//if tx atten cal enabled (and comment out prev. line)
    //this.Loopback = this.ui.Tab.widget(5);//if tx atten cal enabled

    this.setState(false); //disable all buttons

    this.TCXO.PushButton_Tcxo.clicked.connect(this, this.tcxoCalStarted);
    this.RxCW.PushButton_RxCW.clicked.connect(this, this.rxCwCalStarted);
    this.RxPulse.PushButton_RxPulse.clicked.connect(this, this.rxPulseCalStarted);
    this.TxPower.PushButton_Tx.clicked.connect(this, this.txCalStarted);
    //this.TxAtten.PushButton_TxAtten.clicked.connect(this, this.txAttenCalStarted);
    this.Loopback.PushButton_Loopback.clicked.connect(this, this.LoopbackCalStarted);
    this.RFDMCal.PushButton_RFDMCal.clicked.connect(this, this.RFDMCalStarted);

    this.ui.FlagStatus_FactoryCalRunning.changeState.connect(this, this.calibrationStateChanged);

    this.ui.FlagStatus_FactoryCalRunning.hide();
    this.activeCal = "";

    this.setVisibility();

    this.setState(true); //enable all buttons

    this.tile.setWindowTitle("Factory Calibration Menu");

    //print('FactoryCalibration::Initialize exit');
}

Initialize.prototype.tcxoCalStarted = function()
{
    //print('FactoryCalibration::tcxoCalStarted');
    this.calibrationStarted("Tcxo");
}

Initialize.prototype.rxCwCalStarted = function()
{
    //print('FactoryCalibration::rxCwCalStarted');
    this.calibrationStarted("CwReceive");
}

Initialize.prototype.rxPulseCalStarted = function()
{
    //print('FactoryCalibration::rxPulseCalStarted');
    this.calibrationStarted("PulseReceive");
}

Initialize.prototype.txCalStarted = function()
{
    //print('FactoryCalibration::txCalStarted');
    this.calibrationStarted("Tx");
}

//Initialize.prototype.txAttenCalStarted = function()
//{
//    //print('FactoryCalibration::txAttenCalStarted');
//    this.calibrationStarted("TxAtten");
//}

Initialize.prototype.LoopbackCalStarted = function()
{
    //print('FactoryCalibration::LoopbackCalStarted');
    this.calibrationStarted("Loopback");
}

Initialize.prototype.RFDMCalStarted = function()
{
    //print('FactoryCalibration::RFDMCalStarted');
    this.calibrationStarted("RFDM");
}

Initialize.prototype.calibrationStarted = function(calType)
{
    print('>FactoryCalibration::calibrationStarted - '+calType+', '+this.activeCal);

    //triggers initialization of calibration wizard
    calTile = this.engine.getTile("7"); // Calibration wizard
    calWidget = calTile.getContainerFrame();

    this.activeCal = calType;

    switch(calType) {
    case "Tcxo": //TCXO
        this.TCXO.PushButton_Tcxo.setButtonText("Running...");
        break;
    case "CwReceive": //CW_RECEIVE
        this.RxCW.PushButton_RxCW.setButtonText("Running...");
        break;
    case "PulseReceive": //PULSE_RECEIVE
        this.RxPulse.PushButton_RxPulse.setButtonText("Running...");
        break;
    case "Tx": //TX
        this.TxPower.PushButton_Tx.setButtonText("Running...");
        break;
//    case "TxAtten": //TX Atten
//        this.TxAtten.PushButton_TxAtten.setButtonText("Running...");
//        break;
    case "Loopback": //LOOPBACK
        this.Loopback.PushButton_Loopback.setButtonText("Running...");
        break;
    case "RFDMCal": //RFDMCal
        this.RFDMCal.PushButton_RFDMCal.setButtonText("Running...");
        break;
    case "User": //USER
        //print('User is not a factory calibration');
        break;
    case "AltZero": //ALTZERO
        //print('AltZero is not a factory calibration');
        break;
    }

    this.setState(false); //disable all buttons

    try
    {
        //print(' FactoryCalibration::calibrationStarted set currentindex - ' + this.getCalIdx(calType) + ' (' + calType + ')');
        calWidget.stackedWidget_hidden.setCurrentIndex(this.getCalIdx(calType));
    }
    catch(e)
    {
        //print('FactoryCalibration::calibrationStarted::exception - ' + e);
    }

    calTile.show();//display the calibration wizard screen
    //print('<FactoryCalibration::calibrationStarted');
}

Initialize.prototype.calibrationStateChanged = function()
{
    //print('FactoryCalibration::calibrationStateChanged '+this.ui.FlagStatus_FactoryCalRunning.getState()+', '+this.activeCal);
    if("Normal" == this.ui.FlagStatus_FactoryCalRunning.getState() && this.activeCal != "")
        this.finishCalibration(this.activeCal);
}

Initialize.prototype.finishCalibration = function(calType)
{
    //print('>FactoryCalibration::finishCalibration');
    switch(calType) {
    case "Tcxo": //TCXO
        this.TCXO.PushButton_Tcxo.setButtonText("Start");
        break;
    case "CwReceive": //CW_RECEIVE
        this.RxCW.PushButton_RxCW.setButtonText("Start");
        break;
    case "PulseReceive": //PULSE_RECEIVE
        this.RxPulse.PushButton_RxPulse.setButtonText("Start");
        break;
    case "Tx": //TX
        this.TxPower.PushButton_Tx.setButtonText("Disabled");
        break;
//    case "TxAtten": //TX Atten
//        this.TxAtten.PushButton_TxAtten.setButtonText("Start");
//        break;
    case "Loopback": //LOOPBACK
        this.Loopback.PushButton_Loopback.setButtonText("Start");
        break;
    case "RFDM": //RFDMCal
        this.RFDMCal.PushButton_RFDMCal.setButtonText("Start");
        break;
    case "User": //USER
        //print('User is not a factory calibration');
        break;
    case "AltZero": //ALTZERO
        //print('AltZero is not a factory calibration');
        break;
    }

    this.setVisibility();

    this.setState(true); //enable all buttons

    this.activeCal = "";
    //print('<FactoryCalibration::finishCalibration');
}

Initialize.prototype.setState = function(enable)
{
    //print('FactoryCalibration::setState '+enable);
    this.TCXO.PushButton_Tcxo.setEnabled(enable);
    this.RxCW.PushButton_RxCW.setEnabled(enable);
    this.RxPulse.PushButton_RxPulse.setEnabled(enable);
    this.TxPower.PushButton_Tx.setEnabled(false);
    this.TxPower.PushButton_Tx.hide();
    this.TxPower.FlagStatus_Tx.hide();
    //this.TxAtten.PushButton_TxAtten.setEnabled(enable);
    this.Loopback.PushButton_Loopback.setEnabled(enable);
    this.RFDMCal.PushButton_RFDMCal.setEnabled(enable);
}

Initialize.prototype.setVisibility = function()
{
    //print('FactoryCalibration::setVisibility');
    if("Tripped" == this.TCXO.FlagStatus_Tcxo.getState())
        this.TCXO.TimeDate_Tcxo.show();
    else
        this.TCXO.TimeDate_Tcxo.hide();
    if("Tripped" == this.RxCW.FlagStatus_RxCW.getState())
        this.RxCW.TimeDate_RxCW.show();
    else
        this.RxCW.TimeDate_RxCW.hide();
    if("Tripped" == this.RxPulse.FlagStatus_RxPulse.getState())
        this.RxPulse.TimeDate_RxPulse.show();
    else
        this.RxPulse.TimeDate_RxPulse.hide();
    if("Tripped" == this.TxPower.FlagStatus_Tx.getState())
        this.TxPower.TimeDate_Tx.show();
    else
        this.TxPower.TimeDate_Tx.hide();
    //if("Tripped" == this.TxAtten.FlagStatus_TxAtten.getState())
    //    this.TxAtten.TimeDate_TxAtten.show();
    //else
    //    this.TxAtten.TimeDate_TxAtten.hide();
    if("Tripped" == this.Loopback.FlagStatus_Loopback.getState())
        this.Loopback.TimeDate_Loopback.show();
    else
        this.Loopback.TimeDate_Loopback.hide();

    if("Tripped" == this.RFDMCal.FlagStatus_RFDMCal.getState())
        this.RFDMCal.TimeDate_RFDMCal.show();
    else
        this.RFDMCal.TimeDate_RFDMCal.hide();
}

//If the numbers change, update startDelayCal() in RA_delayCalData.js and startAltZero() in RA_setup.js
//and also update NUM_CALIBRATIONS and NUM_FACTORY_CALIBRATIONS in RA_calibrationWizard.js
//and also the number in initializeWizard() in RA_calibrationWizard.js
//and also the number in factoryCalRunningChanged() in RA_calibrationWizard.js
//and also the number in setupWindow() in RA_calibrationWizard.js
//and alter the cases in setButtonVisibility() and setValueVisibility() & setPageText() & getCalType() & getCalTitle() in RA_calibrationWizard.js
Initialize.prototype.getCalIdx = function(type)
{
    var calIdx;

    //print('>FactoryCalibration::getCalIdx '+type);
    switch(type) {
    case "Tcxo": //TCXO
        calIdx = 0;
        break;
    case "CwReceive": //CW_RECEIVE
        calIdx = 1;
        break;
    case "PulseReceive": //PULSE_RECEIVE
        calIdx = 2;
        break;
    case "Tx": //TX
        calIdx = 3;
        break;
//    case "TxAtten": //TX Atten
//        calIdx = 4;
//        break;
    case "Loopback": //LOOPBACK (analog atten cal)
        calIdx = 4;//5;
        break;
    //end of factory cals
    case "User": //USER
        calIdx = 5;//6;
        break;
    case "AltZero": //ALTZERO
        calIdx = 6;//7;
        break;
    case "RFDM": //RFDMCal (RF and Fiber Coil cal)
        calIdx = 7;
        break;
    }
    //print('<FactoryCalibration::getCalIdx returns index '+calIdx);

    return calIdx;
}
