function Initialize(tile, engine, system)
{
    //print('Setup::Initialize entry');

    this.ui = tile.getContainerFrame();
    this.system = system;
    this.engine = engine;
    this.General = this.ui.stackedWidget.main.Tab.widget(0);
    this.Loss = this.ui.stackedWidget.main.Tab.widget(1);
    this.Settings = this.ui.stackedWidget.main.Tab.widget(2);
    this.Display = this.ui.stackedWidget.main.Tab.widget(3);
    //removed the Alt Corr tab so now down to 3 tabs
    //this.AltCorr = this.ui.stackedWidget.main.Tab.widget(2);
    //this.Settings = this.ui.stackedWidget.main.Tab.widget(3);

    this.testRunningChanged(this.ui.stackedWidget.hidden.ToggleButton_TestRunning.getState());
    this.distanceUnitChanged();
    this.powerUnitChanged();
    this.aidModeChanged();
//    this.uutDetectModeChanged();
    this.connectionModeChanged();
//    this.uutTypeChanged();
//    this.showDelayCalResultsScreen();

    this.ui.stackedWidget.hidden.ComboBox_DistanceUnits.guiSetEnum.connect(this, this.distanceUnitsChangedByRci);
    this.ui.stackedWidget.hidden.NumericEntry_CalButtonsLocked.hide();

//    this.General.GroupBox_UutType.ComboBox_UutDetectMode.guiSetEnum.connect(this, this.uutDetectModeChanged);
//    this.General.GroupBox_UutType.ComboBox_UutType.updateEnum.connect(this, this.uutTypeChanged);

 //   this.General.GroupBox_Aid.PushButton_DelayCal.hide();
  //  this.General.GroupBox_Aid.stackedWidget_Calibration.alt_zero.PushButton_AltZero.hide();

//    this.showDelayCalResultsScreen(this.General.PushButton_DelayCal.getState());
//    this.pauseResumeToggled(this.showDelayCalResultsScreen.getState());  /BET 11/4/2020

//    this.General.GroupBox_Aid.PushButton_DelayCal.clicked.connect(this, this.PushButton_DelayCal);  /BET 11/4/2020
    this.General.GroupBox_Aid.PushButton_DelayCal.clicked.connect(this, this.showDelayCalResultsScreen);

    this.General.GroupBox_Aid.stackedWidget_Calibration.alt_zero.PushButton_AltZero.hide();  //Don't allow 9000 to do the alt zero routine
    this.General.GroupBox_Aid.stackedWidget_Calibration.alt_zero.PushButton_AltZero.clicked.connect(this, this.showAltIndZeroInfoScreen);
    this.General.GroupBox_Aid.NumericEntry_offset.setPrecision(1);//force to 1dp so that decimal point button in numeric entry is enabled

//    this.General.GroupBox_Aid.stackedWidget_AID.show_aid.ComboBox_AidMode.guiSetEnum.connect(this, this.aidModeChanged);
//    this.General.GroupBox_Aid.stackedWidget_AID.show_aid.stackedWidget_AID_value.Variable_AID.NumericEntry_VariableAid.unitChanged.connect(this, this.distanceUnitChanged);
    this.General.GroupBox_Aid.NumericEntry_offset.unitChanged.connect(this, this.distanceUnitChanged);

    this.General.GroupBox_RfConn.ComboBox_RfConn.guiSetEnum.connect(this, this.connectionModeChanged);
    this.Loss.GroupBox_CableLoss.NumericEntry_TxCableLoss.unitChanged.connect(this, this.powerUnitChanged);
    this.Loss.GroupBox_CableLoss.NumericEntry_RxCableLoss.unitChanged.connect(this, this.powerUnitChanged);
    this.Loss.GroupBox_CouplerLoss.NumericEntry_AntTxCouplerLoss.unitChanged.connect(this, this.powerUnitChanged);
    this.Loss.GroupBox_CouplerLoss.NumericEntry_AntRxCouplerLoss.unitChanged.connect(this, this.powerUnitChanged);
    this.Loss.GroupBox_ExtAtten.NumericEntry_TxExtAtten.unitChanged.connect(this, this.powerUnitChanged);
    this.Loss.GroupBox_ExtAtten.NumericEntry_RxExtAtten.unitChanged.connect(this, this.powerUnitChanged);

    this.Settings.GroupBox_Settings.TextEntry_SettingName.setDisabled(true);

    this.Settings.GroupBox_Settings.ConfirmationPushButton_Store.clicked.connect(this, this.storeSettingsClicked);
    this.Settings.GroupBox_Settings.ConfirmationPushButton_Recall.clicked.connect(this, this.recallSettingsClicked);
    this.ui.stackedWidget.hidden.ToggleButton_TestRunning.changeState.connect(this, this.testRunningChanged);

    sto = this.system.getSystemScreen("StoreMin");
    rec = this.system.getSystemScreen("RecallMin");

    sto.WindowOpened.connect(this, this.windowOpened);
    rec.WindowOpened.connect(this, this.windowOpened);

    sto.WindowClosed.connect(this, this.windowClosed);
    rec.WindowClosed.connect(this, this.windowClosed);

    tile.WindowClosed.connect(sto, sto.hide);
    tile.WindowClosed.connect(rec, rec.hide);

    //print('$$$$$$$$$$$$$$$$$$$$$$$$$$');
    //print('Setup::Initialize exit');
}

Initialize.prototype.distanceUnitChanged = function()
{
    //print('Setup::distanceUnitChanged');
//    this.setPrecision(this.General.GroupBox_Aid.stackedWidget_AID.show_aid.stackedWidget_AID_value.Variable_AID.NumericEntry_VariableAid);
    //custom behavior for altitude offset in ft
    var unit = this.General.GroupBox_Aid.NumericEntry_offset.getUnit();
    if(unit == "ft")
        this.General.GroupBox_Aid.NumericEntry_offset.setPrecision(1);
    else
        this.setPrecision(this.General.GroupBox_Aid.NumericEntry_offset);
}

Initialize.prototype.distanceUnitsChangedByRci = function()
{
    //update units of altitude offset
    var altOffset = this.General.GroupBox_Aid.NumericEntry_offset.getValue();
    var unit = this.General.GroupBox_Aid.NumericEntry_offset.getUnit();
    //print('Setup::distanceUnitsChangedByRci');
    //print('  initial value = '+altOffset+' '+unit);
    if(0 == this.ui.stackedWidget.hidden.ComboBox_DistanceUnits.getEnum()) { //feet
       //print('  new units are feet');
       if(unit != "ft")
       {
          //change from meters to feet
          this.General.GroupBox_Aid.NumericEntry_offset.setIndex(0);//feet - depends on order of units in ui file so don't change that!
          this.General.GroupBox_Aid.NumericEntry_offset.setPrecision(1);
       }
    }
    else { //meters
       //print('  new units are meters');
       if(unit == "ft")
       {
          //change from feet to meters
          this.General.GroupBox_Aid.NumericEntry_offset.setIndex(1);//meters - depends on order of units in ui file so don't change that!
          this.setPrecision(this.General.GroupBox_Aid.NumericEntry_offset);
       }
    }
}

Initialize.prototype.powerUnitChanged = function()
{
    //print('Setup::powerUnitChanged');
    this.setPrecision(this.Loss.GroupBox_CableLoss.NumericEntry_TxCableLoss);
    this.setPrecision(this.Loss.GroupBox_CableLoss.NumericEntry_RxCableLoss);
    this.setPrecision(this.Loss.GroupBox_CouplerLoss.NumericEntry_AntTxCouplerLoss);
    this.setPrecision(this.Loss.GroupBox_CouplerLoss.NumericEntry_AntRxCouplerLoss);
    this.setPrecision(this.Loss.GroupBox_ExtAtten.NumericEntry_TxExtAtten);
    this.setPrecision(this.Loss.GroupBox_ExtAtten.NumericEntry_RxExtAtten);
}

Initialize.prototype.testRunningChanged = function(state)
{
    var prompt = 0;
    var dialogText = "Are you sure you want to reset to default values?";
    var buttonStyle = 1;

    if(state == "On")
    {
        dialogText = "Cannot reset settings while the test is running.\n\nPlease stop the test from the Simulation screen to continue.";
        buttonStyle = 2;
        prompt = 1;
    }

    //print('Setup::testRunningChanged' + state);

    this.Settings.GroupBox_Settings.ConfirmationPushButton_Store.PromptStyle = prompt;
    this.Settings.GroupBox_Settings.ConfirmationPushButton_Recall.PromptStyle = prompt;
    this.Settings.GroupBox_Settings.ConfirmationPushButton_Reset.PromptStyle = 1;
    this.Settings.GroupBox_Settings.ConfirmationPushButton_Reset.DialogText = dialogText;
    this.Settings.GroupBox_Settings.ConfirmationPushButton_Reset.ButtonStyle = buttonStyle;
}

Initialize.prototype.setPrecision = function(widget)
{
    var unit = widget.getUnit();

    //print('Setup::setPrecision');

    if(unit == "dB" || unit == "dBm") {
        widget.setPrecision(1);
    } else if(unit == "ft" || unit == "ft/s" || unit == "ft/min") { //DISTANCE
        widget.setPrecision(0);
    } else if(unit == "m" || unit == "m/s") {
        widget.setPrecision(2);
    } else if(unit == "W" || unit == "kW" || unit == "MW") {
        widget.setPrecision(4);
    }
}

Initialize.prototype.uutDetectModeChanged = function()
{
    //print('>Setup::uutDetectModeChanged');
    if(0 == this.General.GroupBox_UutType.ComboBox_UutDetectMode.getEnum()) { //Automatic detection
        //print(' Setup::uutDetectModeChanged auto detect');
        this.General.GroupBox_UutType.ComboBox_UutType.setDisabled(true);
        if(this.General.GroupBox_UutType.ComboBox_UutCdfSubType){
            //print('Setup::uutDetectModeChanged disable cdf sub type');
            this.General.GroupBox_UutType.ComboBox_UutCdfSubType.setDisabled(true);
        }
        //print(' Setup::uutDetectModeChanged show alt ind zero');
        this.General.GroupBox_Aid.stackedWidget_Calibration.setCurrentIndex(1); // show
    } else { //manually set
        //print(' Setup::uutDetectModeChanged manual set');
        this.General.GroupBox_UutType.ComboBox_UutType.setEnabled(true);
        if(this.General.GroupBox_UutType.ComboBox_UutCdfSubType){
            //print('Setup::uutDetectModeChanged enable cdf sub type');
            this.General.GroupBox_UutType.ComboBox_UutCdfSubType.setEnabled(true);
        }
        if(2 == this.General.GroupBox_UutType.ComboBox_UutType.getEnum()) { //Pulse type
            //print(' Setup::uutDetectModeChanged hide alt ind zero');
            this.General.GroupBox_Aid.stackedWidget_Calibration.setCurrentIndex(0); // hide
        } else {
            //print(' Setup::uutDetectModeChanged show alt ind zero');
            this.General.GroupBox_Aid.stackedWidget_Calibration.setCurrentIndex(1); // show
        }
    }
    //print('<Setup::uutDetectModeChanged');
}

Initialize.prototype.uutTypeChanged = function()
{
    //print('>Setup::uutTypeChanged');
    if(2 == this.General.GroupBox_UutType.ComboBox_UutType.getEnum()) { //Pulse type
        //print(' Setup::uutTypeChanged pulse');
        if(0 == this.General.GroupBox_UutType.ComboBox_UutDetectMode.getEnum()) { //Automatic detection
            //print(' Setup::uutTypeChanged show alt ind zero');
            this.General.GroupBox_Aid.stackedWidget_Calibration.setCurrentIndex(1); // show
        } else { //manually set
            //print(' Setup::uutTypeChanged hide alt ind zero');
            this.General.GroupBox_Aid.stackedWidget_Calibration.setCurrentIndex(0); // hide
        }
        if(this.General.GroupBox_UutType.ComboBox_UutCdfSubType){
            //print('Setup::uutTypeChanged hide cdf sub type');
            this.General.GroupBox_UutType.ComboBox_UutCdfSubType.hide();
        }
    }
    else if(1 == this.General.GroupBox_UutType.ComboBox_UutType.getEnum()) { //CDF type
        //print(' Setup::uutTypeChanged CDF');
        //print(' Setup::uutTypeChanged show alt ind zero');
        this.General.GroupBox_Aid.stackedWidget_Calibration.setCurrentIndex(1); // show
        if(this.General.GroupBox_UutType.ComboBox_UutCdfSubType){
            //print('Setup::uutTypeChanged show cdf sub type');
            this.General.GroupBox_UutType.ComboBox_UutCdfSubType.show();
        }
    }
    else
    {
        //print(' Setup::uutTypeChanged fmcw, gated fmcw, or other');
        //print(' Setup::uutTypeChanged show alt ind zero');
        this.General.GroupBox_Aid.stackedWidget_Calibration.setCurrentIndex(1); // show
        if(this.General.GroupBox_UutType.ComboBox_UutCdfSubType){
            //print('Setup::uutTypeChanged hide cdf sub type');
            this.General.GroupBox_UutType.ComboBox_UutCdfSubType.hide();
        }
    }
    //print('<Setup::uutTypeChanged');
}

Initialize.prototype.aidModeChanged = function()
{
    //print('Setup::aidModeChanged');
//    if(0 == this.General.GroupBox_Aid.stackedWidget_AID.show_aid.ComboBox_AidMode.getEnum()) { //Fixed AID  the next 4 lines were removed BET 11/6/2020
//        this.General.GroupBox_Aid.stackedWidget_AID.show_aid.stackedWidget_AID_value.setCurrentIndex(0);
//    } else { // Variable AID
//        this.General.GroupBox_Aid.stackedWidget_AID.show_aid.stackedWidget_AID_value.setCurrentIndex(1);
//    }
}

Initialize.prototype.connectionModeChanged = function()
{
    //print('Setup::connectionModeChanged');
    if(0 == this.General.GroupBox_RfConn.ComboBox_RfConn.getEnum()) { //Direct connection:  the next 3 lines were removed BET 11/6/2020
        this.General.GroupBox_Aid.stackedWidget_AID.setCurrentIndex(0); // Show
    } else if(1 == this.General.GroupBox_RfConn.ComboBox_RfConn.getEnum()) { //via Coupler
        this.General.GroupBox_Aid.stackedWidget_AID.setCurrentIndex(1); // Hide
    } else { //via Feeder
        this.General.GroupBox_Aid.stackedWidget_AID.setCurrentIndex(1); // Hide
    }
}

Initialize.prototype.recallSettingsClicked = function()
{
    //print('Setup::recallSettingsClicked');
    store = this.system.getSystemScreen("StoreMin");
    recall = this.system.getSystemScreen("RecallMin");
    if(!store.isVisible() && !recall.isVisible()) {
        recall = this.system.getSystemScreen("RecallMin");
        this.setTableHeader(recall, "Settings Name");
        recall.setWindowTitle("Load Settings");
        recall.show();
        recall.raise();
    } //else {
    //    print('Setup::recallSettingsClicked show warning message (Store/Recall window already open)');
    //    //Use async error reporting to put up a popup box giving an error (Store window already open) TO DO
    //}
}

Initialize.prototype.storeSettingsClicked = function()
{
    //print('Setup::storeSettingsClicked');
    store = this.system.getSystemScreen("StoreMin");
    recall = this.system.getSystemScreen("RecallMin");
    if(!store.isVisible() && !recall.isVisible()) {
        store = this.system.getSystemScreen("StoreMin");
        this.setTableHeader(store, "Settings Name");
        store.setWindowTitle("Manage Settings");
        store.show();
        store.raise();
    } //else {
    //    print('Setup::storeSettingsClicked show warning message (Store/Recall window already open)');
    //    //Use async error reporting to put up a popup box giving an error (Recall window already open) TO DO
    //}
}

//the delay cal results screen is no longer in cal wizard. It is a new screen, number 5.
Initialize.prototype.showDelayCalResultsScreen = function()
{
    //print('>Setup::showDelayCalResultsScreen');

    calTile = this.engine.getTile("5"); // Delay calibration screen - shows the results
    calWidget = calTile.getContainerFrame();

    //is the delay cal start button locked?
    var btnLocked  = calWidget.PushButton_UserStart.Locked;
    var lockedReason = this.ui.stackedWidget.hidden.NumericEntry_CalButtonsLocked.getValue();

    if (btnLocked && (lockedReason == 7))//button is locked due to user delay cal
    {
        calTile = this.engine.getTile("7"); // Calibration wizard screen
    }
    calTile.show();//display the delay cal results screen screen or calibration wizard (for running user cal)

    //print('<Setup::showDelayCalResultsScreen');
}

Initialize.prototype.showAltIndZeroInfoScreen = function()
{
    //print('>Setup::showAltIndZeroInfoScreen');

    calTile = this.engine.getTile("9"); // Altitude Indicator Info screen
    calWidget = calTile.getContainerFrame();

    //is the alt zero button locked?
    var btnLocked = this.General.GroupBox_Aid.stackedWidget_Calibration.alt_zero.PushButton_AltZero.Locked;
    var lockedReason = this.ui.stackedWidget.hidden.NumericEntry_CalButtonsLocked.getValue();

    if (lockedReason == 14)//button is locked due to alt ind zero
    {
        calTile = this.engine.getTile("7"); // Calibration wizard screen
        calTile.show();//display the calibration wizard (for running alt ind zero)
    }
    else
    {
        //start a new alt ind zero
        calTile.show();//display the alt ind zero screen
    }

    //print('<Setup::showAltIndZeroInfoScreen');
}

Initialize.prototype.setTableHeader = function(cont, str)
{
    var tbl = cont.findChild("TableEnum");
    //print('Setup::setTableHeader');
    //print(tbl);
    if(tbl != null)
        tbl.setColumnHeading(str);
}

Initialize.prototype.windowOpened = function()
{
    //print('Setup::windowOpened');
    this.ui.stackedWidget.hidden.ToggleButton_WindowState.attemptState("Opened");
}

Initialize.prototype.windowClosed = function()
{
    //print('Setup::windowClosed');
    this.ui.stackedWidget.hidden.ToggleButton_WindowState.attemptState("Closed");
}
