//var globalUi = 0; //THIS CODE IS SOMETIMES USEFUL TO DEBUG USING SCRIPT DEBUG CONSOLE

var PROFILE_SETUP_NAME = "Profile Setup"

//SCRIPT WRITTEN BASED ON CHANNEL_MAIN_HELPER_OBJECT OF 05/07/2010
function Initialize(tile, engine, system)
{
    this.ui = tile.getContainerFrame();
    this.system = system;
    this.engine = engine;
    this.runningState = "Off";
//    globalUi = tile.getContainerFrame();

    //permanently hidden
    this.ui.ToggleButton_TestRunning.hide();
    this.ui.NumericEntry_CurrentAltitude.hide();
    this.ui.NumericEntry_CurrentTime.hide();
    this.ui.ComboBox_OpMode.hide();
    this.ui.ComboBox_ProfileDisplayUnits.hide();
    
    if(0 != this.ui.ComboBox_ProfileDisplayUnits.getEnum()) { //meters
        //print('Profile Setup:Initialize  Profile display units are meters');
        this.ui.SimulationPlot.setUnits(true); //meters
        this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable.setUnits(true); //meters
    }
    
    this.testRunningChanged(this.ui.ToggleButton_TestRunning.getState());

    this.ui.GroupBox_SimSettings.ConfirmationPushButton_AddLeg.clicked.connect(this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable, "addLegClicked");
    this.ui.GroupBox_SimSettings.ConfirmationPushButton_EditLeg.clicked.connect(this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable, "editLegClicked");
    this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveLeg.clicked.connect(this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable, "removeLegClicked");
    this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveAllLegs.clicked.connect(this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable, "removeAllLegsClicked");
     
    this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable.ValueChanged.connect(this.ui.SimulationPlot, "profileDataChanged");
    this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable.RowSelectionChanged.connect(this, this.tableSelectionChanged);
    this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable.refreshTable(false); //call refresh table so plot widget responds to table update
    this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable.ValueChanged.connect(this, this.anySettingChanged); //call after refreshTable so * isn't added on load

    this.ui.GroupBox_Settings.TextEntry_SettingName.setDisabled(true);
    this.ui.GroupBox_Settings.ConfirmationPushButton_Store.clicked.connect(this, this.storeProfileClicked);
    this.ui.GroupBox_Settings.ConfirmationPushButton_Recall.clicked.connect(this, this.recallProfileClicked);
    this.ui.ToggleButton_TestRunning.changeState.connect(this, this.testRunningChanged);
    
    this.TotalTimeUnitChanged();

    this.ui.NumericEntry_CurrentTime.valueChanged.connect(this.ui.SimulationPlot, "updateMarkerX");
    this.ui.NumericEntry_CurrentAltitude.valueChanged.connect(this.ui.SimulationPlot, "updateMarkerY");
    this.ui.ComboBox_OpMode.guiSetEnum.connect(this, this.opModeChanged);
    this.ui.GroupBox_SimSettings.NumericEntry_TotalDuration.unitChanged.connect(this, this.TotalTimeUnitChanged);
    this.ui.ComboBox_ProfileDisplayUnits.guiSetEnum.connect(this, this.ProfileUnitsChanged);

    sto = this.system.getSystemScreen("StoreMin");
    rec = this.system.getSystemScreen("RecallMin");

    sto.WindowOpened.connect(this, this.windowOpened);
    rec.WindowOpened.connect(this, this.windowOpened);

    sto.WindowClosed.connect(this, this.windowClosed);
    rec.WindowClosed.connect(this, this.windowClosed);

    tile.WindowClosed.connect(sto, sto.hide);
    tile.WindowClosed.connect(rec, rec.hide);

    this.ui.ToggleButton_WindowState.hide();
}

Initialize.prototype.tableSelectionChanged = function(validLeg)
{
    this.selectedLegIsValid = validLeg;
    //print('Profile Setup:tableSelectionChanged - validLeg: ' + validLeg);
    if(this.runningState == "Off")
    {
        if(validLeg)
        {
            this.ui.GroupBox_SimSettings.ConfirmationPushButton_EditLeg.PromptStyle = 0;
            this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveLeg.DialogText = "Are you sure you wish to remove this leg?";
            this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveLeg.ButtonStyle = 1;
        }
        else
        {
            this.ui.GroupBox_SimSettings.ConfirmationPushButton_EditLeg.PromptStyle = 1;
            this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveLeg.DialogText = "Please select a leg to remove.";
            this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveLeg.ButtonStyle = 2;
        }
    }
}

Initialize.prototype.anySettingChanged = function()
{
    //print('Profile Setup:anySettingChanged');
    //var name = this.ui.GroupBox_Settings.TextEntry_SettingName.text();
    //print(' store name is ' + name);
    
    //if(name.charAt(name.length-1) != "*") {
    //    this.ui.GroupBox_Settings.TextEntry_SettingName.setText(name + "*");
    //}
    
    this.TotalTimeUnitChanged();
}

Initialize.prototype.recallProfileClicked = function()
{
    //print('Profile Setup:recallProfileClicked');
    recall = this.system.getSystemScreen("RecallMin");
    store = this.system.getSystemScreen("StoreMin");
    if(!store.isVisible() && !recall.isVisible() && (this.runningState == "Off")) {
        recall = this.system.getSystemScreen("RecallMin");
        this.setTableHeader(recall, "Profile Name");
        recall.setWindowTitle("Load Profile");
        recall.show();
        recall.raise();
    } //else {
    //    print('Profile Setup:recallProfileClicked  show warning message (Store/Recall window already open)');
    //    //Use async error reporting to put up a popup box giving an error (Store window already open) TO DO
    //}
}

Initialize.prototype.storeProfileClicked = function()
{
    //print('Profile Setup:storeProfileClicked');
    recall = this.system.getSystemScreen("RecallMin");
    store = this.system.getSystemScreen("StoreMin");
    if(!store.isVisible() && !recall.isVisible() && (this.runningState == "Off")) {
        store = this.system.getSystemScreen("StoreMin");
        this.setTableHeader(store, "Profile Name");
        store.setWindowTitle("Manage Profiles");
        store.show();
        store.raise();
    } //else {
    //    print('Profile Setup:storeProfileClicked show warning message (Store/Recall window already open)');
    //    //Use async error reporting to put up a popup box giving an error (Recall window already open) TO DO
    //}
}

Initialize.prototype.testRunningChanged = function(state)
{
    //print('Profile Setup:testRunningChanged');
    this.runningState = state;
    var prompt = 0;
    if(state == "On")
    {
        prompt = 1;
        //print('Profile Setup:testRunningChanged  Show airplane');
        this.ui.SimulationPlot.setMarkerVisible(true); //show airplane

        // Change prompts
        this.ui.GroupBox_SimSettings.ConfirmationPushButton_AddLeg.PromptStyle = 1;
        this.ui.GroupBox_SimSettings.ConfirmationPushButton_EditLeg.PromptStyle = 1;
        this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveLeg.ButtonStyle = 2;
        this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveAllLegs.ButtonStyle = 2;

        this.ui.GroupBox_SimSettings.ConfirmationPushButton_AddLeg.DialogText = "Cannot add leg while the test is running.\n\nPlease stop the test from the Simulation screen to continue.";
        this.ui.GroupBox_SimSettings.ConfirmationPushButton_EditLeg.DialogText = "Cannot edit leg while the test is running.\n\nPlease stop the test from the Simulation screen to continue.";
        this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveLeg.DialogText = "Cannot remove leg while the test is running.\n\nPlease stop the test from the Simulation screen to continue.";
        this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveAllLegs.DialogText = "Cannot remove legs while the test is running.\n\nPlease stop the test from the Simulation screen to continue.";
    }
    else if(state == "Off")
    {
        //print('Profile Setup:testRunningChanged  Hide airplane');
        this.ui.SimulationPlot.setMarkerVisible(false); //hide airplane

        // Restore prompts
        this.ui.GroupBox_SimSettings.ConfirmationPushButton_AddLeg.PromptStyle = 0;
        this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveAllLegs.ButtonStyle = 1;

        this.ui.GroupBox_SimSettings.ConfirmationPushButton_EditLeg.DialogText = "Please select a leg to edit.";
        this.ui.GroupBox_SimSettings.ConfirmationPushButton_RemoveAllLegs.DialogText = "Are you sure you wish to remove all legs in this profile?";

        this.tableSelectionChanged(this.selectedLegIsValid);
    }
    
    this.ui.GroupBox_Settings.ConfirmationPushButton_Store.PromptStyle = prompt;
    this.ui.GroupBox_Settings.ConfirmationPushButton_Recall.PromptStyle = prompt;
}

Initialize.prototype.opModeChanged = function()
{
    //print('Profile Setup:opModeChanged');
    if(0 == this.ui.ComboBox_OpMode.getEnum()) { //Manual Operation Mode
        //print('Profile Setup:opModeChanged  Hide airplane');
        this.ui.SimulationPlot.setMarkerVisible(false); //hide airplane
    } else {
        //print('Profile Setup:opModeChanged  Show airplane');
        this.ui.SimulationPlot.setMarkerVisible(true); //show airplane
    }
}

Initialize.prototype.ProfileUnitsChanged = function()
{
    //print('>Profile Setup:ProfileUnitsChanged');
    if(0 == this.ui.ComboBox_ProfileDisplayUnits.getEnum()) { //Feet
        //print('Profile Setup:ProfileUnitsChanged to feet');
        this.ui.SimulationPlot.setUnits(false); //feet
        this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable.setUnits(false); //feet
    } else { //Meters
        //print('Profile Setup:ProfileUnitsChanged to meters');
        this.ui.SimulationPlot.setUnits(true); //meters
        this.ui.GroupBox_SimSettings.CustomWidget_SimulationTable.setUnits(true); //meters
    }
    //print('<Profile Setup:ProfileUnitsChanged');
}

Initialize.prototype.setTableHeader = function(cont, str)
{
    //print('Profile Setup:setTableHeader' + str);
    var tbl = cont.findChild("TableEnum");
    //print(tbl);
    if(tbl != null)
        tbl.setColumnHeading(str);
}

Initialize.prototype.TotalTimeUnitChanged = function()
{
    //print('Profile Setup:TotalTimeUnitChanged');
    this.setPrecision(this.ui.GroupBox_SimSettings.NumericEntry_TotalDuration);
}

Initialize.prototype.setPrecision = function(widget)
{
    //print('Profile Setup:setPrecision');
    var unit = widget.getUnit();
    //different dp for min or h units
    if(unit == "min") {
        widget.setPrecision(0);
    } else if(unit == "h") {
        widget.setPrecision(2);
    }
}

Initialize.prototype.windowOpened = function()
{
    //print('Profile Setup::windowOpened');
    this.ui.ToggleButton_WindowState.attemptState("Opened");
}

Initialize.prototype.windowClosed = function()
{
    //print('Profile Setup::windowClosed');
    this.ui.ToggleButton_WindowState.attemptState("Closed");
}
